scala.collection.immutable

# StringLike

#### trait StringLike[+Repr] extends IndexedSeqOptimized[Char, Repr] with Ordered[String]

A trait describing stringlike collections.

Repr

  The type of the actual collection inheriting `StringLike`.

Self Type
  StringLike[Repr]
Source
  StringLike.scala
Since

  2.8

Linear Supertypes
math.Ordered[String], Comparable[String], IndexedSeqOptimized[Char, Repr], IndexedSeqLike[Char, Repr], SeqLike[Char, Repr], GenSeqLike[Char, Repr], IterableLike[Char, Repr], GenIterableLike[Char, Repr], TraversableLike[Char, Repr], GenTraversableLike[Char, Repr], Parallelizable[Char, ParSeq[Char]], TraversableOnce[Char], GenTraversableOnce[Char], FilterMonadic[Char, Repr], HasNewBuilder[Char, Repr], Equals, Any
Known Subclasses
StringBuilder, StringOps, WrappedString
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. StringLike
2. Ordered
3. Comparable
4. IndexedSeqOptimized
5. IndexedSeqLike
6. SeqLike
7. GenSeqLike
8. IterableLike
9. GenIterableLike
10. TraversableLike
11. GenTraversableLike
12. Parallelizable
13. TraversableOnce
14. GenTraversableOnce
15. FilterMonadic
16. HasNewBuilder
17. Equals
18. Any

Implicitly

1. by traversable2ops
2. by MonadOps
3. by orderingToOrdered
4. by any2stringadd
5. by any2stringfmt
6. by any2ArrowAssoc
7. by any2Ensuring
8. by alternateImplicit

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class Elements extends AbstractIterator[A] with BufferedIterator[A] with Serializable

   The class of the iterator returned by the `iterator` method.

2. #### type Self = Repr

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

3. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Abstract Value Members

1. #### abstract def getClass(): Class[_]

   Returns the runtime class representation of the object.

   Returns the runtime class representation of the object.

   returns

     a class object corresponding to the runtime type of the receiver.

   Definition Classes
     Any

2. #### abstract def newBuilder: Builder[Char, Repr]

   Creates a string builder buffer as builder for this class

   Creates a string builder buffer as builder for this class

   Attributes
     protected[this]
   Definition Classes
     StringLike → TraversableLike → HasNewBuilder

3. #### abstract def seq: collection.IndexedSeq[Char]

   A version of this collection with all of the operations implemented sequentially (i.

   A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

   This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

   returns

     a sequential view of the collection.

   Definition Classes
     IndexedSeqLike → GenSeqLike → Parallelizable → TraversableOnce → GenTraversableOnce

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     Any

3. #### def *(n: Int): String

   Return the current string concatenated `n` times.

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ++[B](that: GenTraversableOnce[B]): String[B]

   [use case] Returns a new string containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new string containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the string is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = LinkedList(1)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val b = LinkedList(2)
       b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val c = a ++ b
       c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

       scala> val d = LinkedList('a')
       d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

       scala> val e = c ++ d
       e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new string which contains all elements of this string followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike
   Full Signature

   #### def ++[B >: Char, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

6. #### def ++:[B >: Char, That](that: collection.Traversable[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this string followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### def ++:[B](that: TraversableOnce[B]): String[B]

   [use case] As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   [use case]

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new string which contains all elements of this string followed by all elements of `that`.

   Definition Classes
     TraversableLike
   Full Signature

   #### def ++:[B >: Char, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

8. #### def +:(elem: A): String[A]

   [use case] A copy of the string with an element prepended.

   [use case]

   A copy of the string with an element prepended.

   Note that :-ending operators are right associative (see example). A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

   Also, the original string is not modified, so you will want to capture the result.

   Example:

       scala> val x = LinkedList(1)
       x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

       scala> val y = 2 +: x
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

       scala> println(x)
       LinkedList(1)

   elem

     the prepended element

   returns

     a new string consisting of `elem` followed by all elements of this string.

   Definition Classes
     SeqLike → GenSeqLike
   Full Signature

   #### def +:[B >: Char, That](elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

9. #### def ->[B](y: B): (StringLike[Repr], B)

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to ArrowAssoc[StringLike[Repr]] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline ()

10. #### def /:[B](z: B)(op: (B, Char) ⇒ B): B

    Applies a binary operator to a start value and all elements of this string, going left to right.

    Applies a binary operator to a start value and all elements of this string, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = (5 /: a)(_+_)
        b: Int = 15

        scala> val c = (5 /: a)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this string, going left to right with the start value `z` on the left:

          op(...op(op(z, x_1), x_2), ..., x_n)

      where `x1, ..., xn` are the elements of this string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

11. #### def :+(elem: A): String[A]

    [use case] A copy of this string with an element appended.

    [use case]

    A copy of this string with an element appended.

    A mnemonic for `+:` vs. `:+` is: the COLon goes on the COLlection side.

    Example:

        scala> import scala.collection.mutable.LinkedList
        import scala.collection.mutable.LinkedList

        scala> val a = LinkedList(1)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

        scala> val b = a :+ 2
        b: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

        scala> println(a)
        LinkedList(1)

    elem

      the appended element

    returns

      a new string consisting of all elements of this string followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def :+[B >: Char, That](elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

12. #### def :\[B](z: B)(op: (Char, B) ⇒ B): B

    Applies a binary operator to all elements of this string and a start value, going right to left.

    Applies a binary operator to all elements of this string and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = (a :\ 5)(_+_)
        b: Int = 15

        scala> val c = (a :\ 5)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this string, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

13. #### def <(that: String): Boolean

    Returns true if `this` is less than `that`

    Returns true if `this` is less than `that`

    Definition Classes
      Ordered

14. #### def <=(that: String): Boolean

    Returns true if `this` is less than or equal to `that`.

    Returns true if `this` is less than or equal to `that`.

    Definition Classes
      Ordered

15. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

16. #### def >(that: String): Boolean

    Returns true if `this` is greater than `that`.

    Returns true if `this` is greater than `that`.

    Definition Classes
      Ordered

17. #### def >=(that: String): Boolean

    Returns true if `this` is greater than or equal to `that`.

    Returns true if `this` is greater than or equal to `that`.

    Definition Classes
      Ordered

18. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this string to a string builder.

    Appends all elements of this string to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this string without any separator string.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

19. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this string to a string builder using a separator string.

    Appends all elements of this string to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this string, separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

20. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this string to a string builder using start, end, and separator strings.

    Appends all elements of this string to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this string are separated by the string `sep`.

    Example:

        scala> val a = LinkedList(1,2,3,4)
        a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, "LinkedList(", ", ", ")")
        res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

21. #### def aggregate[B](z: B)(seqop: (B, Char) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

22. #### def apply(n: Int): Char

    Return element at index `n`

    Return element at index `n`

    returns

      the element of this string at index `idx`, where `0` indicates the first element.

    Definition Classes
      StringLike → SeqLike → GenSeqLike
    Exceptions thrown
      IndexOutOfBoundsException

      if the index is not valid

23. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

24. #### def asParIterable: ParIterable[Char]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to TraversableOps[Char] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

25. #### def asParSeq: ParSeq[Char]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to TraversableOps[Char] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

26. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this string should be compared

    returns

      `true`, if this string can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

27. #### def capitalize: String

    Returns this string with first character converted to upper case

28. #### def collect[B](pf: PartialFunction[A, B]): String[B]

    [use case] Builds a new collection by applying a partial function to all elements of this string on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this string on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the string.

    returns

      a new string resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike
    Full Signature

    #### def collect[B, That](pf: PartialFunction[Char, B])(implicit bf: CanBuildFrom[Repr, B, That]): That

29. #### def collectFirst[B](pf: PartialFunction[Char, B]): Option[B]

    Finds the first element of the string for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the string for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

30. #### def combinations(n: Int): Iterator[Repr]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this string.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

31. #### def compare(other: String): Int

    Result of comparing `this` with operand `that`.

    Result of comparing `this` with operand `that`.

    Implement this method to determine how instances of A will be sorted.

    Returns `x` where:

    - `x < 0` when `this < that`
    - `x == 0` when `this == that`
    - `x > 0` when `this > that`
    Definition Classes
      StringLike → Ordered

32. #### def compareTo(that: String): Int

    Result of comparing `this` with operand `that`.

    Result of comparing `this` with operand `that`.

    Definition Classes
      Ordered → Comparable

33. #### def contains(elem: Any): Boolean

    Tests whether this string contains a given value as an element.

    Tests whether this string contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this string has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

34. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this string contains a given sequence as a slice.

    Tests whether this string contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this string contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

35. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this string to an array.

    [use case]

    Copies elements of this string to an array. Fills the given array `xs` with at most `len` elements of this string, starting at position `start`. Copying will stop once either the end of the current string is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: Char](xs: Array[B], start: Int, len: Int): Unit

36. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this string to an array.

    [use case]

    Copies values of this string to an array. Fills the given array `xs` with values of this string. Copying will stop once either the end of the current string is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: Char](xs: Array[B]): Unit

37. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this string to an array.

    [use case]

    Copies values of this string to an array. Fills the given array `xs` with values of this string, beginning at index `start`. Copying will stop once either the end of the current string is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: Char](xs: Array[B], start: Int): Unit

38. #### def copyToBuffer[B >: Char](dest: Buffer[B]): Unit

    Copies all elements of this string to a buffer.

    Copies all elements of this string to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

39. #### def corresponds[B](that: GenSeq[B])(p: (Char, B) ⇒ Boolean): Boolean

    Tests whether every element of this string relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this string relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this string and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

40. #### def count(p: (Char) ⇒ Boolean): Int

    Counts the number of elements in the string which satisfy a predicate.

    Counts the number of elements in the string which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

41. #### def diff(that: collection.Seq[Char]): String[Char]

    [use case] Computes the multiset difference between this string and another sequence.

    [use case]

    Computes the multiset difference between this string and another sequence.

    that

      the sequence of elements to remove

    returns

      a new string which contains all elements of this string except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def diff[B >: Char](that: GenSeq[B]): Repr

42. #### def distinct: Repr

    Builds a new string from this string without any duplicate elements.

    Builds a new string from this string without any duplicate elements.

    returns

      A new string which contains the first occurrence of every element of this string.

    Definition Classes
      SeqLike → GenSeqLike

43. #### def drop(n: Int): Repr

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this string.

    returns

      a string consisting of all elements of this string except the first `n` ones, or else the empty string, if this string has less than `n` elements.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

44. #### def dropRight(n: Int): Repr

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a string consisting of all elements of this string except the last `n` ones, or else the empty string, if this string has less than `n` elements.

    Definition Classes
      IndexedSeqOptimized → IterableLike

45. #### def dropWhile(p: (Char) ⇒ Boolean): Repr

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    returns

      the longest suffix of this string whose first element does not satisfy the predicate `p`.

    Definition Classes
      IndexedSeqOptimized → TraversableLike → GenTraversableLike

46. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this string ends with the given sequence.

    Tests whether this string ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this string has `that` as a suffix, `false` otherwise.

    Definition Classes
      IndexedSeqOptimized → SeqLike → GenSeqLike

47. #### def ensuring(cond: (StringLike[Repr]) ⇒ Boolean, msg: ⇒ Any): StringLike[Repr]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to Ensuring[StringLike[Repr]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

48. #### def ensuring(cond: (StringLike[Repr]) ⇒ Boolean): StringLike[Repr]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to Ensuring[StringLike[Repr]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

49. #### def ensuring(cond: Boolean, msg: ⇒ Any): StringLike[Repr]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to Ensuring[StringLike[Repr]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

50. #### def ensuring(cond: Boolean): StringLike[Repr]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to Ensuring[StringLike[Repr]] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

51. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → Any

52. #### def exists(p: (Char) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this string.

    Tests whether a predicate holds for some of the elements of this string.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this string, otherwise `false`.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

53. #### def filter(p: (Char) ⇒ Boolean): Repr

    Selects all elements of this string which satisfy a predicate.

    Selects all elements of this string which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new string consisting of all elements of this string that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

54. #### def filterNot(p: (Char) ⇒ Boolean): Repr

    Selects all elements of this string which do not satisfy a predicate.

    Selects all elements of this string which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new string consisting of all elements of this string that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

55. #### def find(p: (Char) ⇒ Boolean): Option[Char]

    Finds the first element of the string satisfying a predicate, if any.

    Finds the first element of the string satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the string that satisfies `p`, or `None` if none exists.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

56. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): String[B]

    [use case] Builds a new collection by applying a function to all elements of this string and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this string and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of string. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be a an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new string resulting from applying the given collection-valued function `f` to each element of this string and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def flatMap[B, That](f: (Char) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

57. #### def fold[A1 >: Char](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this string using the specified associative binary operator.

    Folds the elements of this string using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

58. #### def foldLeft[B](z: B)(op: (B, Char) ⇒ B): B

    Applies a binary operator to a start value and all elements of this string, going left to right.

    Applies a binary operator to a start value and all elements of this string, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this string, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this string.

    Definition Classes
      IndexedSeqOptimized → TraversableOnce → GenTraversableOnce

59. #### def foldRight[B](z: B)(op: (Char, B) ⇒ B): B

    Applies a binary operator to all elements of this string and a start value, going right to left.

    Applies a binary operator to all elements of this string and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this string, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this string.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce

60. #### def forall(p: (Char) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this string.

    Tests whether a predicate holds for all elements of this string.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this string, otherwise `false`.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

61. #### def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this string.

    [use case]

    Applies a function `f` to all elements of this string.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Full Signature

    #### def foreach[U](f: (Char) ⇒ U): Unit

62. #### def format(args: Any*): String

    Uses the underlying string as a pattern (in a fashion similar to printf in C), and uses the supplied arguments to fill in the holes.

    Uses the underlying string as a pattern (in a fashion similar to printf in C), and uses the supplied arguments to fill in the holes.

    The interpretation of the formatting patterns is described in `java.util.Formatter`, with the addition that classes deriving from `ScalaNumber` (such as scala.BigInt and scala.BigDecimal) are unwrapped to pass a type which `Formatter` understands.

    args

      the arguments used to instantiating the pattern.

    Exceptions thrown
      `java.lang.IllegalArgumentException`

63. #### def formatLocal(l: Locale, args: Any*): String

    Like `format(args*)` but takes an initial `Locale` parameter which influences formatting as in `java.lang.String`'s format.

    Like `format(args*)` but takes an initial `Locale` parameter which influences formatting as in `java.lang.String`'s format.

    The interpretation of the formatting patterns is described in `java.util.Formatter`, with the addition that classes deriving from `ScalaNumber` (such as `scala.BigInt` and `scala.BigDecimal`) are unwrapped to pass a type which `Formatter` understands.

    l

      an instance of `java.util.Locale`

    args

      the arguments used to instantiating the pattern.

    Exceptions thrown
      `java.lang.IllegalArgumentException`

64. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline ()

65. #### def groupBy[K](f: (Char) ⇒ K): Map[K, Repr]

    Partitions this string into a map of strings according to some discriminator function.

    Partitions this string into a map of strings according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new string.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to strings such that the following invariant holds:

          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a string of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

66. #### def grouped(size: Int): Iterator[Repr]

    Partitions elements in fixed size strings.

    Partitions elements in fixed size strings.

    size

      the number of elements per group

    returns

      An iterator producing strings of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `grouped`

67. #### def hasDefiniteSize: Boolean

    Tests whether this string is known to have a finite size.

    Tests whether this string is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

68. #### def hashCode(): Int

    Hashcodes for `String` produce a value from the hashcodes of all the elements of the string.

    Hashcodes for `String` produce a value from the hashcodes of all the elements of the string.

    returns

      the hash code value for this object.

    Definition Classes
      IndexedSeqLike → GenSeqLike → Any

69. #### def head: Char

    Selects the first element of this string.

    Selects the first element of this string.

    returns

      the first element of this string.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the string is empty.

70. #### def headOption: Option[Char]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this string if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

71. #### def ifParSeq[R](isbody: (ParSeq[Char]) ⇒ R): (TraversableOps[Char])#Otherwise[R]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to TraversableOps[Char] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

72. #### def indexOf(elem: Char, from: Int): Int

    [use case] Finds index of first occurrence of some value in this string after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this string after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this string that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: Char](elem: B, from: Int): Int

73. #### def indexOf(elem: Char): Int

    [use case] Finds index of first occurrence of some value in this string.

    [use case]

    Finds index of first occurrence of some value in this string.

    elem

      the element value to search for.

    returns

      the index of the first element of this string that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def indexOf[B >: Char](elem: B): Int

74. #### def indexOfSlice[B >: Char](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this string contains a given sequence as a slice.

    Finds first index after or at a start index where this string contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this string starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

75. #### def indexOfSlice[B >: Char](that: GenSeq[B]): Int

    Finds first index where this string contains a given sequence as a slice.

    Finds first index where this string contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this string starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

76. #### def indexWhere(p: (Char) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this string that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      IndexedSeqOptimized → SeqLike → GenSeqLike

77. #### def indexWhere(p: (Char) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this string that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

78. #### def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this string.

    Definition Classes
      SeqLike

79. #### def init: Repr

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a string consisting of all elements of this string except the last one.

    Definition Classes
      IndexedSeqOptimized → TraversableLike → GenTraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the string is empty.

80. #### def inits: Iterator[Repr]

    Iterates over the inits of this string.

    Iterates over the inits of this string. The first value will be this string and the final one will be an empty string, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this string

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

81. #### def intersect(that: collection.Seq[Char]): String[Char]

    [use case] Computes the multiset intersection between this string and another sequence.

    [use case]

    Computes the multiset intersection between this string and another sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new string which contains all elements of this string which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike → GenSeqLike
    Full Signature

    #### def intersect[B >: Char](that: GenSeq[B]): Repr

82. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this string contains given index.

    Tests whether this string contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this string contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

83. #### def isEmpty: Boolean

    Tests whether this string is empty.

    Tests whether this string is empty.

    returns

      `true` if the string contain no elements, `false` otherwise.

    Definition Classes
      IndexedSeqOptimized → SeqLike → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

84. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

85. #### def isParIterable: Boolean

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to TraversableOps[Char] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

86. #### def isParSeq: Boolean

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to TraversableOps[Char] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

87. #### def isParallel: Boolean

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to TraversableOps[Char] performed by method traversable2ops in scala.collection.parallel.
    Definition Classes
      TraversableOps

88. #### final def isTraversableAgain: Boolean

    Tests whether this string can be repeatedly traversed.

    Tests whether this string can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      TraversableLike → GenTraversableLike → GenTraversableOnce

89. #### def iterator: Iterator[Char]

    Creates a new iterator over all elements contained in this iterable object.

    Creates a new iterator over all elements contained in this iterable object.

    returns

      the new iterator

    Definition Classes
      IndexedSeqLike → IterableLike → GenIterableLike

90. #### def last: Char

    Selects the last element.

    Selects the last element.

    returns

      The last element of this string.

    Definition Classes
      IndexedSeqOptimized → TraversableLike → GenTraversableLike
    Exceptions thrown
      NoSuchElementException

      If the string is empty.

91. #### def lastIndexOf(elem: Char, end: Int): Int

    [use case] Finds index of last occurrence of some value in this string before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this string before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this string that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: Char](elem: B, end: Int): Int

92. #### def lastIndexOf(elem: Char): Int

    [use case] Finds index of last occurrence of some value in this string.

    [use case]

    Finds index of last occurrence of some value in this string.

    elem

      the element value to search for.

    returns

      the index of the last element of this string that is equal (as determined by `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike
    Full Signature

    #### def lastIndexOf[B >: Char](elem: B): Int

93. #### def lastIndexOfSlice[B >: Char](that: GenSeq[B], end: Int): Int

    Finds last index before or at a given end index where this string contains a given sequence as a slice.

    Finds last index before or at a given end index where this string contains a given sequence as a slice.

    that

      the sequence to test

    end

      the end index

    returns

      the last index `<= end` such that the elements of this string starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

94. #### def lastIndexOfSlice[B >: Char](that: GenSeq[B]): Int

    Finds last index where this string contains a given sequence as a slice.

    Finds last index where this string contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the last index such that the elements of this string starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

95. #### def lastIndexWhere(p: (Char) ⇒ Boolean, end: Int): Int

    Finds index of last element satisfying some predicate before or at given end index.

    Finds index of last element satisfying some predicate before or at given end index.

    p

      the predicate used to test elements.

    returns

      the index `<= end` of the last element of this string that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      IndexedSeqOptimized → SeqLike → GenSeqLike

96. #### def lastIndexWhere(p: (Char) ⇒ Boolean): Int

    Finds index of last element satisfying some predicate.

    Finds index of last element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the last element of this string that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

97. #### def lastOption: Option[Char]

    Optionally selects the last element.

    Optionally selects the last element.

    returns

      the last element of this string$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike → GenTraversableLike

98. #### def length: Int

    The length of the string.

    The length of the string.

    Note: `xs.length` and `xs.size` yield the same result.

    returns

      the number of elements in this string.

    Definition Classes
      StringLike → SeqLike → GenSeqLike

99. #### def lengthCompare(len: Int): Int

    Compares the length of this string to a test value.

    Compares the length of this string to a test value.

    len

      the test value that gets compared with the length.

    returns

      A value `x` where

          x <  0       if this.length <  len
          x == 0       if this.length == len
          x >  0       if this.length >  len

      The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

    Definition Classes
      IndexedSeqOptimized → SeqLike

100. #### def lines: Iterator[String]

     Return all lines in this string in an iterator, excluding trailing line end characters, i.

     Return all lines in this string in an iterator, excluding trailing line end characters, i.e. apply `.stripLineEnd` to all lines returned by `linesWithSeparators`.

101. #### def linesIterator: Iterator[String]

     Return all lines in this string in an iterator, excluding trailing line end characters, i.

     Return all lines in this string in an iterator, excluding trailing line end characters, i.e. apply `.stripLineEnd` to all lines returned by `linesWithSeparators`.

102. #### def linesWithSeparators: Iterator[String]

     Return all lines in this string in an iterator, including trailing line end characters.

     Return all lines in this string in an iterator, including trailing line end characters.

     The number of strings returned is one greater than the number of line end characters in this string. For an empty string, a single empty line is returned. A line end character is one of

     - `LF` - line feed (`0x0A` hex)
     - `FF` - form feed (`0x0C` hex)

103. #### def map[B](f: (A) ⇒ B): String[B]

     [use case] Builds a new collection by applying a function to all elements of this string.

     [use case]

     Builds a new collection by applying a function to all elements of this string.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new string resulting from applying the given function `f` to each element of this string and collecting the results.

     Definition Classes
       TraversableLike → GenTraversableLike → FilterMonadic
     Full Signature

     #### def map[B, That](f: (Char) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

104. #### def max: A

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this string.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def max[B >: Char](implicit cmp: Ordering[B]): Char

105. #### def maxBy[B](f: (Char) ⇒ B)(implicit cmp: Ordering[B]): Char

     Definition Classes
       TraversableOnce → GenTraversableOnce

106. #### def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this string

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def min[B >: Char](implicit cmp: Ordering[B]): Char

107. #### def minBy[B](f: (Char) ⇒ B)(implicit cmp: Ordering[B]): Char

     Definition Classes
       TraversableOnce → GenTraversableOnce

108. #### def mkString: String

     Displays all elements of this string in a string.

     Displays all elements of this string in a string.

     returns

       a string representation of this string. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this string follow each other without any separator string.

     Definition Classes
       StringLike → TraversableOnce → GenTraversableOnce

109. #### def mkString(sep: String): String

     Displays all elements of this string in a string using a separator string.

     Displays all elements of this string in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this string. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this string are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

110. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this string in a string using start, end, and separator strings.

     Displays all elements of this string in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this string. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this string are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

111. #### def nonEmpty: Boolean

     Tests whether the string is not empty.

     Tests whether the string is not empty.

     returns

       `true` if the string contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

112. #### def padTo(len: Int, elem: A): String[A]

     [use case] A copy of this string with an element value appended until a given target length is reached.

     [use case]

     A copy of this string with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new string consisting of all elements of this string followed by the minimal number of occurrences of `elem` so that the resulting string has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def padTo[B >: Char, That](len: Int, elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

113. #### def par: ParSeq[Char]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

114. #### def parCombiner: Combiner[Char, ParSeq[Char]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → TraversableLike → Parallelizable

115. #### def partition(p: (Char) ⇒ Boolean): (Repr, Repr)

     Partitions this string in two strings according to a predicate.

     Partitions this string in two strings according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of strings: the first string consists of all elements that satisfy the predicate `p` and the second string consists of all elements that don't. The relative order of the elements in the resulting strings is the same as in the original string.

     Definition Classes
       TraversableLike → GenTraversableLike

116. #### def patch(from: Int, that: GenSeq[A], replaced: Int): String[A]

     [use case] Produces a new string where a slice of elements in this string is replaced by another sequence.

     [use case]

     Produces a new string where a slice of elements in this string is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original string

     returns

       a new string consisting of all elements of this string except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def patch[B >: Char, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[Repr, B, That]): That

117. #### def permutations: Iterator[Repr]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this string.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

118. #### def prefixLength(p: (Char) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this string such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

119. #### def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements in this string of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the string and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def product[B >: Char](implicit num: Numeric[B]): B

120. #### def r(groupNames: String*): Regex

     You can follow a string with `.r(g1, ... , gn)`, turning it into a `Regex`, with group names g1 through gn.

     You can follow a string with `.r(g1, ... , gn)`, turning it into a `Regex`, with group names g1 through gn.

     `"""(\d\d)-(\d\d)-(\d\d\d\d)""".r("month", "day", "year")` matches dates and provides its subcomponents through groups named "month", "day" and "year".

     groupNames

       The names of the groups in the pattern, in the order they appear.

121. #### def r: Regex

     You can follow a string with `.r`, turning it into a `Regex`.

     You can follow a string with `.r`, turning it into a `Regex`. E.g.

     `"""A\w*""".r` is the regular expression for identifiers starting with `A`.

122. #### def reduce[A1 >: Char](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this string using the specified associative binary operator.

     Reduces the elements of this string using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the string is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this string is empty.

123. #### def reduceLeft[B >: Char](op: (B, Char) ⇒ B): B

     Applies a binary operator to all elements of this string, going left to right.

     Applies a binary operator to all elements of this string, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this string, going left to right:

           op( op( ... op(x_1, x_2) ..., x_{n-1}), x_n)

       where `x1, ..., xn` are the elements of this string.

     Definition Classes
       IndexedSeqOptimized → TraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this string is empty.

124. #### def reduceLeftOption[B >: Char](op: (B, Char) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this string, going left to right.

     Optionally applies a binary operator to all elements of this string, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this string is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

125. #### def reduceOption[A1 >: Char](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this string, if any, using the specified associative binary operator.

     Reduces the elements of this string, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

126. #### def reduceRight[B >: Char](op: (Char, B) ⇒ B): B

     Applies a binary operator to all elements of this string, going right to left.

     Applies a binary operator to all elements of this string, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this string, going right to left:

           op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

       where `x1, ..., xn` are the elements of this string.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this string is empty.

127. #### def reduceRightOption[B >: Char](op: (Char, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this string, going right to left.

     Optionally applies a binary operator to all elements of this string, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this string is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

128. #### def replaceAllLiterally(literal: String, replacement: String): String

     Replace all literal occurrences of `literal` with the string `replacement`.

     Replace all literal occurrences of `literal` with the string `replacement`. This is equivalent to java.lang.String#replaceAll except that both arguments are appropriately quoted to avoid being interpreted as metacharacters.

     literal

       the string which should be replaced everywhere it occurs

     replacement

       the replacement string

     returns

       the resulting string

129. #### def repr: Repr

     The collection of type string underlying this `TraversableLike` object.

     The collection of type string underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

130. #### def reverse: Repr

     Returns new string wih elements in reversed order.

     Returns new string wih elements in reversed order.

     returns

       A new string with all elements of this string in reversed order.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

131. #### def reverseIterator: Iterator[Char]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this string in reversed order

     Definition Classes
       IndexedSeqOptimized → SeqLike

132. #### def reverseMap[B](f: (A) ⇒ B): String[B]

     [use case] Builds a new collection by applying a function to all elements of this string and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this string and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new string resulting from applying the given function `f` to each element of this string and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def reverseMap[B, That](f: (Char) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

133. #### def reversed: scala.List[Char]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

134. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this string.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this string.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike
     Full Signature

     #### def sameElements[B >: Char](that: GenIterable[B]): Boolean

135. #### def scan[B >: Char, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[Repr, B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new string containing the prefix scan of the elements in this string

     Definition Classes
       TraversableLike → GenTraversableLike

136. #### def scanLeft[B, That](z: B)(op: (B, Char) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

     Produces a collection containing cumulative results of applying the operator going left to right.

     Produces a collection containing cumulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

137. #### def scanRight[B, That](z: B)(op: (Char, B) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

138. #### def segmentLength(p: (Char) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this string starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

139. #### def size: Int

     The size of this string, equivalent to `length`.

     The size of this string, equivalent to `length`.

     returns

       the number of elements in this string.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

140. #### def slice(from: Int, until: Int): Repr

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

         from <= indexOf(x) < until

     returns

       a string containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this string.

     Definition Classes
       StringLike → IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

141. #### def sliding(size: Int, step: Int): Iterator[Repr]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     step

       the distance between the first elements of successive groups (defaults to 1)

     returns

       An iterator producing strings of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

142. #### def sliding(size: Int): Iterator[Repr]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing strings of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

143. #### def sortBy[B](f: (Char) ⇒ B)(implicit ord: math.Ordering[B]): Repr

     Sorts this `String` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this `String` according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a string consisting of the elements of this string sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.     val words = "The quick brown fox jumped over the lazy dog".split(' ')
            // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
            words.sortBy(x => (x.length, x.head))
            res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

144. #### def sortWith(lt: (Char, Char) ⇒ Boolean): Repr

     Sorts this string according to a comparison function.

     Sorts this string according to a comparison function.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a string consisting of the elements of this string sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.     List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
            List("Bob", "John", "Steve", "Tom")

145. #### def sorted[B >: Char](implicit ord: math.Ordering[B]): Repr

     Sorts this string according to an Ordering.

     Sorts this string according to an Ordering.

     The sort is stable. That is, elements that are equal (as determined by `lt`) appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a string consisting of the elements of this string sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

146. #### def span(p: (Char) ⇒ Boolean): (Repr, Repr)

     Splits this string into a prefix/suffix pair according to a predicate.

     Splits this string into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     returns

       a pair consisting of the longest prefix of this string whose elements all satisfy `p`, and the rest of this string.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike

147. #### def split(separators: Array[Char]): Array[String]

     Annotations
       @throws ( cause = ... )

148. #### def split(separator: Char): Array[String]

     Annotations
       @throws ( cause = ... )

149. #### def splitAt(n: Int): (Repr, Repr)

     Splits this string into two at a given position.

     Splits this string into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of strings consisting of the first `n` elements of this string, and the other elements.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike

150. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this string contains the given sequence at a given index.

     Tests whether this string contains the given sequence at a given index.

     Note: If the both the receiver object `this` and the argument `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this string at index `offset`, otherwise `false`.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

151. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this string starts with the given sequence.

     Tests whether this string starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

152. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this string. By default the string prefix is the simple name of the collection class string.

     Definition Classes
       TraversableLike → GenTraversableLike

153. #### def stripLineEnd: String

     Strip trailing line end character from this string if it has one.

     Strip trailing line end character from this string if it has one.

     A line end character is one of

     - `LF` - line feed (`0x0A` hex)
     - `FF` - form feed (`0x0C` hex)

     If a line feed character `LF` is preceded by a carriage return `CR` (`0x0D` hex), the `CR` character is also stripped (Windows convention).

154. #### def stripMargin: String

     For every line in this string:

     For every line in this string:

     Strip a leading prefix consisting of blanks or control characters followed by `|` from the line.

155. #### def stripMargin(marginChar: Char): String

     For every line in this string:

     For every line in this string:

     Strip a leading prefix consisting of blanks or control characters followed by `marginChar` from the line.

156. #### def stripPrefix(prefix: String): String

     Returns this string with the given `prefix` stripped.

157. #### def stripSuffix(suffix: String): String

     Returns this string with the given `suffix` stripped.

     Returns this string with the given `suffix` stripped. If this string does not end with `suffix`, it is returned unchanged.

158. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this string of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the string and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: Char](implicit num: Numeric[B]): B

159. #### def tail: Repr

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a string consisting of all elements of this string except the first one.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the string is empty.

160. #### def tails: Iterator[Repr]

     Iterates over the tails of this string.

     Iterates over the tails of this string. The first value will be this string and the final one will be an empty string, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this string

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

161. #### def take(n: Int): Repr

     Selects first n elements.

     Selects first n elements.

     n

       the number of elements to take from this string.

     returns

       a string consisting only of the first `n` elements of this string, or else the whole string, if it has less than `n` elements.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

162. #### def takeRight(n: Int): Repr

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a string consisting only of the last `n` elements of this string, or else the whole string, if it has less than `n` elements.

     Definition Classes
       IndexedSeqOptimized → IterableLike

163. #### def takeWhile(p: (Char) ⇒ Boolean): Repr

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     returns

       the longest prefix of this string whose elements all satisfy the predicate `p`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

164. #### def thisCollection: collection.IndexedSeq[Char]

     The underlying collection seen as an instance of ``String``.

     The underlying collection seen as an instance of ``String``. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike

165. #### def to[Col[_]]: Col[A]

     [use case] Converts this string into another by copying all elements.

     [use case]

     Converts this string into another by copying all elements.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this string.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, Char, Col[Char]]): Col[Char]

166. #### def toArray: Array[A]

     [use case] Converts this string to an array.

     [use case]

     Converts this string to an array.

     returns

       an array containing all elements of this string. An `ClassTag` must be available for the element type of this string.

     Definition Classes
       StringLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: Char](implicit arg0: ClassTag[B]): Array[B]

167. #### def toBoolean: Boolean

168. #### def toBuffer[A1 >: Char]: Buffer[A1]

     Converts this string to a mutable buffer.

     Converts this string to a mutable buffer.

     returns

       a buffer containing all elements of this string.

     Definition Classes
       IndexedSeqLike → TraversableOnce → GenTraversableOnce

169. #### def toByte: Byte

170. #### def toCollection(repr: Repr): collection.IndexedSeq[Char]

     A conversion from collections of type `Repr` to ``String`` objects.

     A conversion from collections of type `Repr` to ``String`` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike

171. #### def toDouble: Double

172. #### def toFloat: Float

173. #### def toIndexedSeq: IndexedSeq[Char]

     Converts this string to an indexed sequence.

     Converts this string to an indexed sequence.

     returns

       an indexed sequence containing all elements of this string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

174. #### def toInt: Int

175. #### def toIterable: collection.Iterable[Char]

     Converts this string to an iterable collection.

     Converts this string to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this string.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

176. #### def toIterator: Iterator[Char]

     Returns an Iterator over the elements in this string.

     Returns an Iterator over the elements in this string. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this string.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

177. #### def toList: scala.List[Char]

     Converts this string to a list.

     Converts this string to a list.

     returns

       a list containing all elements of this string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

178. #### def toLong: Long

179. #### def toMap[T, U]: collection.Map[T, U]

     [use case] Converts this string to a map.

     [use case]

     Converts this string to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map of type `immutable.Map[T, U]` containing all key/value pairs of type `(T, U)` of this string.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toMap[T, U](implicit ev: <:<[Char, (T, U)]): Map[T, U]

180. #### def toParArray: ParArray[Char]

     Implicit information
       This member is added by an implicit conversion from StringLike[Repr] to TraversableOps[Char] performed by method traversable2ops in scala.collection.parallel.
     Definition Classes
       TraversableOps

181. #### def toSeq: collection.Seq[Char]

     Converts this string to a sequence.

     Converts this string to a sequence.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this string.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

182. #### def toSet[B >: Char]: Set[B]

     Converts this string to a set.

     Converts this string to a set.

     returns

       a set containing all elements of this string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

183. #### def toShort: Short

184. #### def toStream: Stream[Char]

     Converts this string to a stream.

     Converts this string to a stream.

     returns

       a stream containing all elements of this string.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

185. #### def toString(): String

     Converts this string to a string.

     Converts this string to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this string, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → Any

186. #### def toTraversable: collection.Traversable[Char]

     Converts this string to an unspecified Traversable.

     Converts this string to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this string.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

187. #### def toVector: scala.Vector[Char]

     Converts this string to a Vector.

     Converts this string to a Vector.

     returns

       a vector containing all elements of this string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

188. #### def union(that: collection.Seq[Char]): String[Char]

     [use case] Produces a new sequence which contains all elements of this string and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this string and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     that

       the sequence to add.

     returns

       a new string which contains all elements of this string followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def union[B >: Char, That](that: GenSeq[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

189. #### def updated(index: Int, elem: A): String[A]

     [use case] A copy of this string with one single replaced element.

     [use case]

     A copy of this string with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a copy of this string with the element at position `index` replaced by `elem`.

     Definition Classes
       SeqLike → GenSeqLike
     Full Signature

     #### def updated[B >: Char, That](index: Int, elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

190. #### def view(from: Int, until: Int): SeqView[Char, Repr]

     Creates a non-strict view of a slice of this string.

     Creates a non-strict view of a slice of this string.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current string, whereas `slice` produces a new string.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this string, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

191. #### def view: SeqView[Char, Repr]

     Creates a non-strict view of this string.

     Creates a non-strict view of this string.

     returns

       a non-strict view of this string.

     Definition Classes
       SeqLike → IterableLike → TraversableLike

192. #### def withFilter(p: (Char) ⇒ Boolean): FilterMonadic[Char, Repr]

     Creates a non-strict filter of this string.

     Creates a non-strict filter of this string.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this string which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

193. #### def zip[B](that: GenIterable[B]): String[(A, B)]

     [use case] Returns a string formed from this string and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a string formed from this string and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new string containing pairs consisting of corresponding elements of this string and `that`. The length of the returned collection is the minimum of the lengths of this string and `that`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike
     Full Signature

     #### def zip[A1 >: Char, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[Repr, (A1, B), That]): That

194. #### def zipAll[B](that: collection.Iterable[B], thisElem: A, thatElem: B): String[(A, B)]

     [use case] Returns a string formed from this string and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a string formed from this string and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this string is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this string.

     returns

       a new string containing pairs consisting of corresponding elements of this string and `that`. The length of the returned collection is the maximum of the lengths of this string and `that`. If this string is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this string, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipAll[B, A1 >: Char, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[Repr, (A1, B), That]): That

195. #### def zipWithIndex: String[(A, Int)]

     [use case] Zips this string with its indices.

     [use case]

     Zips this string with its indices.

     returns

       A new string containing pairs consisting of all elements of this string paired with their index. Indices start at `0`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[A1 >: Char, That](implicit bf: CanBuildFrom[Repr, (A1, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

196. #### def →[B](y: B): (StringLike[Repr], B)

     Implicit information
       This member is added by an implicit conversion from StringLike[Repr] to ArrowAssoc[StringLike[Repr]] performed by method any2ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implict Value Members

1. #### def <(that: StringLike[Repr]): Boolean

   Returns true if `this` is less than `that`

   Returns true if `this` is less than `that`

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to math.Ordered[StringLike[Repr]] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[StringLike[Repr]] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: math.Ordered[StringLike[Repr]]).<(that)

   Definition Classes
     Ordered

2. #### def <=(that: StringLike[Repr]): Boolean

   Returns true if `this` is less than or equal to `that`.

   Returns true if `this` is less than or equal to `that`.

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to math.Ordered[StringLike[Repr]] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[StringLike[Repr]] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: math.Ordered[StringLike[Repr]]).<=(that)

   Definition Classes
     Ordered

3. #### def >(that: StringLike[Repr]): Boolean

   Returns true if `this` is greater than `that`.

   Returns true if `this` is greater than `that`.

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to math.Ordered[StringLike[Repr]] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[StringLike[Repr]] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: math.Ordered[StringLike[Repr]]).>(that)

   Definition Classes
     Ordered

4. #### def >=(that: StringLike[Repr]): Boolean

   Returns true if `this` is greater than or equal to `that`.

   Returns true if `this` is greater than or equal to `that`.

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to math.Ordered[StringLike[Repr]] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[StringLike[Repr]] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: math.Ordered[StringLike[Repr]]).>=(that)

   Definition Classes
     Ordered

5. #### def compare(that: StringLike[Repr]): Int

   Result of comparing `this` with operand `that`.

   Result of comparing `this` with operand `that`.

   Implement this method to determine how instances of A will be sorted.

   Returns `x` where:

   - `x < 0` when `this < that`
   - `x == 0` when `this == that`
   - `x > 0` when `this > that`
   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to math.Ordered[StringLike[Repr]] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[StringLike[Repr]] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: math.Ordered[StringLike[Repr]]).compare(that)

   Definition Classes
     Ordered

6. #### def compareTo(that: StringLike[Repr]): Int

   Result of comparing `this` with operand `that`.

   Result of comparing `this` with operand `that`.

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to math.Ordered[StringLike[Repr]] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[StringLike[Repr]] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: math.Ordered[StringLike[Repr]]).compareTo(that)

   Definition Classes
     Ordered → Comparable

7. #### def filter(p: (Char) ⇒ Boolean): TraversableOnce[Char]

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: MonadOps[Char]).filter(p)

   Definition Classes
     MonadOps

8. #### def flatMap[B](f: (Char) ⇒ GenTraversableOnce[B]): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: MonadOps[Char]).flatMap(f)

   Definition Classes
     MonadOps

9. #### def map[B](f: (Char) ⇒ B): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (stringLike: MonadOps[Char]).map(f)

   Definition Classes
     MonadOps

10. #### val self: Any

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to StringAdd performed by method any2stringadd in scala.Predef.
    Shadowing
      This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
      To access this member you can use a type ascription:

          (stringLike: StringAdd).self

    Definition Classes
      StringAdd

11. #### val self: Any

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to StringFormat performed by method any2stringfmt in scala.Predef.
    Shadowing
      This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
      To access this member you can use a type ascription:

          (stringLike: StringFormat).self

    Definition Classes
      StringFormat

12. #### def withFilter(p: (Char) ⇒ Boolean): Iterator[Char]

    Implicit information
      This member is added by an implicit conversion from StringLike[Repr] to MonadOps[Char] performed by method MonadOps in scala.collection.TraversableOnce.
    Shadowing
      This implicitly inherited member is shadowed by one or more members in this class.
      To access this member you can use a type ascription:

          (stringLike: MonadOps[Char]).withFilter(p)

    Definition Classes
      MonadOps

### Deprecated Value Members

1. #### def /:\[A1 >: Char](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

       scala> val a = LinkedList(1,2,3,4)
       a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

       scala> val b = (a /:\ 5)(_+_)
       b: Int = 15

   Definition Classes
     GenTraversableOnce
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) use fold instead

2. #### def x: StringLike[Repr]

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to ArrowAssoc[StringLike[Repr]] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (stringLike: ArrowAssoc[StringLike[Repr]]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

3. #### def x: StringLike[Repr]

   Implicit information
     This member is added by an implicit conversion from StringLike[Repr] to Ensuring[StringLike[Repr]] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (stringLike: Ensuring[StringLike[Repr]]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from math.Ordered[String]

### Inherited from Comparable[String]

### Inherited from IndexedSeqOptimized[Char, Repr]

### Inherited from IndexedSeqLike[Char, Repr]

### Inherited from SeqLike[Char, Repr]

### Inherited from GenSeqLike[Char, Repr]

### Inherited from IterableLike[Char, Repr]

### Inherited from GenIterableLike[Char, Repr]

### Inherited from TraversableLike[Char, Repr]

### Inherited from GenTraversableLike[Char, Repr]

### Inherited from Parallelizable[Char, ParSeq[Char]]

### Inherited from TraversableOnce[Char]

### Inherited from GenTraversableOnce[Char]

### Inherited from FilterMonadic[Char, Repr]

### Inherited from HasNewBuilder[Char, Repr]

### Inherited from Equals

### Inherited from Any

### Inherited by implicit conversion traversable2ops from StringLike[Repr] to TraversableOps[Char]

### Inherited by implicit conversion MonadOps from StringLike[Repr] to MonadOps[Char]

### Inherited by implicit conversion orderingToOrdered from StringLike[Repr] to math.Ordered[StringLike[Repr]]

### Inherited by implicit conversion any2stringadd from StringLike[Repr] to StringAdd

### Inherited by implicit conversion any2stringfmt from StringLike[Repr] to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from StringLike[Repr] to ArrowAssoc[StringLike[Repr]]

### Inherited by implicit conversion any2Ensuring from StringLike[Repr] to Ensuring[StringLike[Repr]]

### Inherited by implicit conversion alternateImplicit from StringLike[Repr] to ForceImplicitAmbiguity

### Ungrouped